Wt: Wt::WBoxLayout Class Reference

Wt 3.3.0

- Main Page
- Related Pages
- Modules
- Namespaces
- Classes

- Class List
- Class Hierarchy
- Class Members

Public Types | Public Member Functions
Wt::WBoxLayout Class Reference

A layout manager which arranges widgets horizontally or vertically. More...

`#include <Wt/WBoxLayout>`

Inheritance diagram for Wt::WBoxLayout:
[legend]

List of all members.

## Public Types
enum | Direction { LeftToRight, RightToLeft, TopToBottom, BottomToTop }
| Enumeration of the direction in which widgets are layed out. More...
## Public Member Functions
| WBoxLayout (Direction dir, WWidget *parent=0)
| Creates a new box layout.
virtual void | addItem (WLayoutItem *item)
| Adds a layout item.
virtual void | removeItem (WLayoutItem *item)
| Removes a layout item (widget or nested layout).
virtual WLayoutItem * | itemAt (int index) const
| Returns the layout item at a specific index.
virtual int | count () const
| Returns the number of items in this layout.
virtual void | clear ()
| Removes and deletes all child widgets and nested layouts.
void | setDirection (Direction direction)
| Sets the layout direction.
Direction | direction () const
| Returns the layout direction.
void | setSpacing (int size)
| Sets spacing between each item.
int | spacing () const
| Returns the spacing between each item.
void | addWidget (WWidget *widget, int stretch=0, WFlags< AlignmentFlag > alignment=0)
| Adds a widget to the layout.
void | addLayout (WLayout *layout, int stretch=0, WFlags< AlignmentFlag > alignment=0)
| Adds a nested layout to the layout.
void | addSpacing (const WLength &size)
| Adds extra spacing.
void | addStretch (int stretch=0)
| Adds a stretch element.
void | insertWidget (int index, WWidget *widget, int stretch=0, WFlags< AlignmentFlag > alignment=0)
| Inserts a widget in the layout.
void | insertLayout (int index, WLayout *layout, int stretch=0, WFlags< AlignmentFlag > alignment=0)
| Inserts a nested layout in the layout.
void | insertSpacing (int index, const WLength &size)
| Inserts extra spacing in the layout.
void | insertStretch (int index, int stretch=0)
| Inserts a stretch element in the layout.
bool | setStretchFactor (WLayout *layout, int stretch)
| Sets the stretch factor for a nested layout.
bool | setStretchFactor (WWidget *widget, int stretch)
| Sets the stretch factor for a widget.
void | setResizable (int index, bool enabled=true, const WLength &initialSize=WLength::Auto)
| Sets whether the use may drag a particular border.
bool | isResizable (int index) const
| Returns whether the user may drag a particular border.

## Detailed Description

A layout manager which arranges widgets horizontally or vertically.

This layout manager arranges widgets horizontally or vertically inside the parent container.

The space is divided so that each widget is given its preferred size, and remaining space is divided according to stretch factors among widgets. If not all widgets can be given their preferred size (there is not enough room), then widgets are given a smaller size (down to their minimum size). If necessary, the container (or parent layout) of this layout is resized to meet minimum size requirements.

The preferred width or height of a widget is based on its natural size, where it presents its contents without overflowing. WWidget::resize() or (CSS `width`, `height` properties) can be used to adjust the preferred size of a widget.

The minimum width or height of a widget is based on the minimum dimensions of the widget or the nested layout. The default minimum height or width for a widget is 0. It can be specified using WWidget::setMinimumSize() or using CSS `min-width` or `min-height` properties.

You should use WContainerWidget::setOverflow(OverflowAuto) or use a WScrollArea to automatically show scrollbars for widgets inserted in the layout to cope with a size set by the layout manager that is smaller than the preferred size.

When the container of a layout manager has a maximum size set using WWidget::setMaximumSize(), then the size of the container will be based on the preferred size of the contents, up to this maximum size, instead of the default behaviour of constraining the size of the children based on the size of the container.

A layout manager may provide resize handles between items which allow the user to change the automatic layout provided by the layout manager (see setResizable()).

Each item is separated using a constant spacing, which defaults to 6 pixels, and can be changed using setSpacing(). In addition, when this layout is a top-level layout (i.e. is not nested inside another layout), a margin is set around the contents. This margin defaults to 9 pixels, and can be changed using setContentsMargins(). You can add more space between two widgets using addSpacing().

For each item a stretch factor may be defined, which controls how remaining space is used. Each item is stretched using the stretch factor to fill the remaining space.

Usage example:

     Wt::WContainerWidget *w = new Wt::WContainerWidget(this);
     w->resize(WLength(), 600);

     Wt::WBoxLayout *layout = new Wt::WBoxLayout(Wt::WBoxLayout::TopToBottom);
     layout->addWidget(new Wt::WText("One"));
     layout->addWidget(new Wt::WText("Two"));
     layout->addWidget(new Wt::WText("Three"));
     layout->addWidget(new Wt::WText("Four"));

     w->setLayout(layout);

Note:
  This layout manager is applicable only to WContainerWidget container widgets. You may use it within an Ext::Container indirectly by first setting a WContainerWidget using a WFitLayout.
  When JavaScript support is not available, not all functionality of the layout is available. In particular, vertical size management is not available.
  When a layout is used on a first page with progressive bootstrap, then the layout will progress only in a limited way to a full JavaScript-based layout. You can thus not rely on it to behave properly for example when dynamically adding or removing widgets.

## Member Enumeration Documentation

enum Wt::WBoxLayout::Direction

Enumeration of the direction in which widgets are layed out.

Enumerator:

  LeftToRight | Horizontal layout, widgets are arranged from left to right.
  RightToLeft | Horizontal layout, widgets are arranged from right to left.
  TopToBottom | Vertical layout, widgets are arranged from top to bottom.
  BottomToTop | Vertical layout, widgets are arranged from bottom to top.

## Constructor & Destructor Documentation

Wt::WBoxLayout::WBoxLayout | ( | Direction | dir,
|  | WWidget * | parent = `0`
| ) |  |

Creates a new box layout.

This constructor is rarely used. Instead, use the convenient constructors of the specialized WHBoxLayout or WVBoxLayout classes.

Use `parent` = `0` to created a layout manager that can be nested inside other layout managers.

## Member Function Documentation

void Wt::WBoxLayout::addItem | ( | WLayoutItem * | item | ) | `[virtual]`

Adds a layout item.

The item may be a widget or nested layout.

How the item is layed out with respect to siblings is implementation specific to the layout manager. In some cases, a layout manager will overload this method with extra arguments that specify layout options.

See also:
  removeItem(WLayoutItem *), addWidget(WWidget *)

Implements Wt::WLayout.

void Wt::WBoxLayout::addLayout | ( | WLayout * | layout,
|  | int | stretch = `0`,
|  | WFlags< AlignmentFlag > | alignment = `0`
| ) |  |

Adds a nested layout to the layout.

Adds a nested layout, with given `stretch` factor.

See also:
  addWidget(WWidget *, int, WFlags<AlignmentFlag>), insertLayout()

void Wt::WBoxLayout::addSpacing | ( | const WLength & | size | ) |

Adds extra spacing.

Adds extra spacing to the layout.

See also:
  addStretch(), insertStretch()

void Wt::WBoxLayout::addStretch | ( | int | stretch = `0` | ) |

Adds a stretch element.

Adds a stretch element to the layout. This adds an empty space that stretches as needed.

See also:
  addSpacing(), insertStretch()

void Wt::WBoxLayout::addWidget | ( | WWidget * | widget,
|  | int | stretch = `0`,
|  | WFlags< AlignmentFlag > | alignment = `0`
| ) |  |

Adds a widget to the layout.

Adds a widget to the layout, with given `stretch` factor. When the stretch factor is 0, the widget will not be resized by the layout manager (stretched to take excess space).

The `alignment` parameter is a combination of a horizontal and/or a vertical AlignmentFlag OR'ed together.

The `alignment` specifies the vertical and horizontal alignment of the item. The default value 0 indicates that the item is stretched to fill the entire column or row. The alignment can be specified as a logical combination of a horizontal alignment (Wt::AlignLeft, Wt::AlignCenter, or Wt::AlignRight) and a vertical alignment (Wt::AlignTop, Wt::AlignMiddle, or Wt::AlignBottom).

See also:
  addLayout(), insertWidget()

void Wt::WBoxLayout::clear | ( |  | ) | `[virtual]`

Removes and deletes all child widgets and nested layouts.

This is similar to WContainerWidget::clear(), with the exception that the layout itself is not deleted.

Implements Wt::WLayout.

int Wt::WBoxLayout::count | ( |  | ) | const`[virtual]`

Returns the number of items in this layout.

This may be a theoretical number, which is greater than the actual number of items. It can be used to iterate over the items in the layout, in conjunction with itemAt().

Implements Wt::WLayout.

Direction Wt::WBoxLayout::direction | ( |  | ) | const

Returns the layout direction.

See also:
  setDirection()

void Wt::WBoxLayout::insertLayout | ( | int | index,
|  | WLayout * | layout,
|  | int | stretch = `0`,
|  | WFlags< AlignmentFlag > | alignment = `0`
| ) |  |

Inserts a nested layout in the layout.

Inserts a nested layout in the layout at position`index`, with given `stretch` factor.

See also:
  insertWidget(), addLayout()

void Wt::WBoxLayout::insertSpacing | ( | int | index,
|  | const WLength & | size
| ) |  |

Inserts extra spacing in the layout.

Inserts extra spacing in the layout at position `index`.

See also:
  insertStretch(), addSpacing()

void Wt::WBoxLayout::insertStretch | ( | int | index,
|  | int | stretch = `0`
| ) |  |

Inserts a stretch element in the layout.

Inserts a stretch element in the layout at position `index`. This adds an empty space that stretches as needed.

See also:
  insertSpacing(), addStretch()

void Wt::WBoxLayout::insertWidget | ( | int | index,
|  | WWidget * | widget,
|  | int | stretch = `0`,
|  | WFlags< AlignmentFlag > | alignment = `0`
| ) |  |

Inserts a widget in the layout.

Inserts a widget in the layout at position `index`, with given `stretch` factor. When the stretch factor is 0, the widget will not be resized by the layout manager (stretched to take excess space).

The `alignment` specifies the vertical and horizontal alignment of the item. The default value 0 indicates that the item is stretched to fill the entire column or row. The alignment can be specified as a logical combination of a horizontal alignment (Wt::AlignLeft, Wt::AlignCenter, or Wt::AlignRight) and a vertical alignment (Wt::AlignTop, Wt::AlignMiddle, or Wt::AlignBottom).

See also:
  insertLayout(), addWidget(WWidget *, int, WFlags<AlignmentFlag>)

bool Wt::WBoxLayout::isResizable | ( | int | index | ) | const

Returns whether the user may drag a particular border.

This method returns whether the border that separates item index from the next item may be resized by the user.

See also:
  setResizable()

WLayoutItem * Wt::WBoxLayout::itemAt | ( | int | index | ) | const`[virtual]`

Returns the layout item at a specific index.

If there is no item at the `index`, `0` is returned.

See also:
  indexOf(WLayoutItem *) const, count()

Implements Wt::WLayout.

void Wt::WBoxLayout::removeItem | ( | WLayoutItem * | item | ) | `[virtual]`

Removes a layout item (widget or nested layout).

See also:
  addItem(WLayoutItem *), removeWidget(WWidget *)

Implements Wt::WLayout.

void Wt::WBoxLayout::setDirection | ( | Direction | direction | ) |

Sets the layout direction.

See also:
  direction()

void Wt::WBoxLayout::setResizable | ( | int | index,
|  | bool | enabled = `true`,
|  | const WLength & | initialSize = `WLength::Auto`
| ) |  |

Sets whether the use may drag a particular border.

This method sets whether the border that separates item index from the next item may be resized by the user, depending on the value of enabled.

The default value is false.

If an `initialSize` is given (that is not WLength::Auto), then this size is used for the size of the item, overriding the size it would be given by the layout manager.

void Wt::WBoxLayout::setSpacing | ( | int | size | ) |

Sets spacing between each item.

The default spacing is 6 pixels.

bool Wt::WBoxLayout::setStretchFactor | ( | WLayout * | layout,
|  | int | stretch
| ) |  |

Sets the stretch factor for a nested layout.

The `layout` must have previously been added to this layout using insertLayout() or addLayout().

Returns whether the `stretch` could be set.

bool Wt::WBoxLayout::setStretchFactor | ( | WWidget * | widget,
|  | int | stretch
| ) |  |

Sets the stretch factor for a widget.

The `widget` must have previously been added to this layout using insertWidget() or addWidget().

Returns whether the `stretch` could be set.

int Wt::WBoxLayout::spacing | ( |  | ) | const

Returns the spacing between each item.

See also:
  setSpacing()

All Classes Namespaces Functions Variables Typedefs Enumerations Enumerator